# -*- coding: utf-8 -*-

__author__	= 'Souheil CHELFOUH <souheil@chelfouh.com>'
__docformat__	= 'plaintext'

print '--- Initializing product StructuredDocument ---'

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.Archetypes import listTypes, process_types
from Products.StructuredDocument.config import *

# Add object implements
import catalog

# Register skin directories so they can be added to portal_skins
registerDirectory('skins', product_globals)

def initialize(context):
    """
    Init my product : StructuredDocument
    """
    import security as perms
    import contents
    
    # initialize the content, including types and add permissions
    listOfTypes = listTypes(PROJECTNAME)
    content_types, constructors, ftis = process_types(listOfTypes,
                                                      PROJECTNAME)

    allTypes = zip(content_types, constructors)
    for atype, constructor in allTypes:
        kind = "%s: %s" % (PROJECTNAME, atype.archetype_name)
        utils.ContentInit(
            kind,
            content_types      = (atype,),
            permission         = getattr(perms, 'Add%s' % atype.meta_type),
            extra_constructors = (constructor,),
            fti                = ftis,
            ).initialize(context)
