# -*- coding: utf-8 -*-

from Products.Archetypes.public import DisplayList

# My project
PROJECTNAME = "StructuredDocument"

# Globals
product_globals = globals()

# Types using portal factory
FACTORY = ('StructuredDocument',
           'SimpleChapter',
           'SimpleParagraph',
           'ListingParagraph',
           'ImageCollection',
           'BlockCharacter',
           'BlockCountry')

# Types to hide from navigation
HIDDEN = ('StructuredChapter',
          'SimpleChapter',
          'SimpleParagraph',
          'ImageCollection',
          'ListingParagraph',
          'BlockCharacter',
          'BlockCountry')

# Metatype not to query for nav
NO_QUERY = ('StructuredDocument',)

# Kupu conf
MEDIAOBJECT = list()
COLLECTION  = ('ImageCollection',)
LINKABLE    = ('StructuredDocument',
               'SimpleChapter',
               'ImageCollection')

# Stylesheets
STYLESHEETS = (
    {'id'       : 'structured_document.css',
     'media'    : 'screen',
     'rendering': 'import'
     },
    {'id'       : 'thickbox.css',
     'media'    : 'screen',
     'rendering': 'import'
     },
    )

# Image sizes
ORIGINAL_SIZE = (600,600)

TAG_SIZES = {
    'thumb' :   (100,100),
    'normal':   (200,200),
    'medium':   (300,300),
    'large' :   (400,400)
    }

TAG_NAMES = DisplayList((lambda l: (l.sort(), l.reverse(), l)[2])
                        ([(k, '%d x %d pixels' % v) for k, v in TAG_SIZES.items()]))

# Javascripts
JAVASCRIPTS = (
    {'id': 'jquery.js',},
    {'id': 'thickbox.js',},
    {'id': 'structured_document_effects.js',}, 
)
