# -*- coding: utf-8 -*-

# Imports: Zope
from AccessControl  import ClassSecurityInfo
from zope.interface import implements

# Imports: Archetypes
from Products.Archetypes.public import registerType

# Imports: Structured Document
from Products.StructuredDocument.config          import PROJECTNAME
from Products.StructuredDocument.schemas         import BlockCharacterSchema
from Products.StructuredDocument.interfaces      import IBlockCharacter
from Products.StructuredDocument.contents.mixins import StructuredBlock


class BlockCharacter( StructuredBlock ):
    """
    A block containing informations about an historical
    character. It contains datas such as birthdate, nationality...
    This item has got not historic since it's not really useful here.
    """
    # Configuration of my type
    portal_type = metal_type    = "BlockCharacter"
    archetype_name              = "Character block"
    content_icon                = "block_character_icon.gif"
    typeDescription             = "A block of information about a character"
    typeDescMsgId               = "block_character_desc"
    schema                      = BlockCharacterSchema
    global_allow                = False
    
    # Z3 implements
    implements( IBlockCharacter )

    # Security
    security = ClassSecurityInfo()

    # Methods
    security.declareProtected('View', 'tag')
    def tag(self, **kwargs):
        """
        Generate image tag using the api of the ImageField
        We use it here to provide a convenient way to display
        thumbnail and also to fit the summary_view requirement
        """
        if self.getPortrait():
            if not 'scale' in kwargs:
                kwargs['scale'] = self.getImage_scale() or 'normal'
            return self.getWrappedField('portrait').tag(self, **kwargs)
            
        return None


registerType(BlockCharacter, PROJECTNAME)
