# -*- coding: utf-8 -*-

# Imports: Zope
from AccessControl  import ClassSecurityInfo
from zope.interface import implements

# Imports: Archetypes
from Products.Archetypes.public import registerType

# Imports: Structured Document
from Products.StructuredDocument.config          import PROJECTNAME
from Products.StructuredDocument.schemas         import BlockCountrySchema
from Products.StructuredDocument.interfaces      import IBlockCountry
from Products.StructuredDocument.contents.mixins import StructuredBlock


class BlockCountry( StructuredBlock ):
    """
    A block containing informations about a country.
    It contains a flag, informations about the population,
    type of government, etc...
    """
    # Configuration of my type
    portal_type = metal_type    = "BlockCountry"
    archetype_name              = "Country block"
    content_icon                = "block_country_icon.gif"
    typeDescription             = "A block of information about a country"
    typeDescMsgId               = "block_country_desc"
    schema                      = BlockCountrySchema
    global_allow                = False
    
    # Z3 implements
    implements( IBlockCountry )

    # Security
    security = ClassSecurityInfo()

    # Methods
    security.declareProtected('View', 'tag')
    def tag(self, **kwargs):
        """
        Generate image tag using the api of the ImageField
        We use it here to provide a convenient way to display
        thumbnail and also to fit the summary_view requirement
        """
        if self.getFlag():
            if not 'scale' in kwargs:
                kwargs['scale'] = self.getImage_scale() or 'normal'
            return self.getWrappedField('flag').tag(self, **kwargs)
            
        return None


registerType(BlockCountry, PROJECTNAME)
