# -*- coding: utf-8 -*-

# Imports: Zope
from zope.interface import implements

# Imports: Archetypes
from Products.Archetypes.public import registerType

# Imports: Structured Document
from Products.StructuredDocument.config          import PROJECTNAME
from Products.StructuredDocument.interfaces      import ISimpleChapter
from Products.StructuredDocument.interfaces      import IImageCollection
from Products.StructuredDocument.contents.mixins import StructuredContainer


class SimpleChapter( StructuredContainer ):
    """ A very simple chapter inside a document """

    # Configuration of my type
    portal_type = metal_type    = "SimpleChapter"
    archetype_name              = "Chapter"
    content_icon                = "simple_chapter_icon.gif"
    typeDescription             = "A division inside a document"
    typeDescMsgId               = "simple_chapter_desc"
    global_allow                = False

    # Z3 implements
    implements( ISimpleChapter )

    # Views
    default_view                = 'structured_chapter_view'
    immediate_view              = 'structured_chapter_view'
    suppl_views                 = tuple()
    
    # Contents
    allowed_content_types       = ('Image',
                                   'ImageCollection',
                                   'SimpleParagraph',
                                   'ListingParagraph')


class ImageCollection( StructuredContainer ):
    """ An image collection inside a document """

    # Configuration of my type
    portal_type = metal_type    = "ImageCollection"
    archetype_name              = "Image collection"
    content_icon                = "image_collection_icon.gif"
    typeDescription             = "An image collection inside a document"
    typeDescMsgId               = "image_collection_desc"
    global_allow                = False

    # Z3 implements
    implements( IImageCollection )

    # Views
    default_view                = 'structured_chapter_view'
    immediate_view              = 'structured_chapter_view'
    suppl_views                 = tuple()
    
    # Contents
    allowed_content_types       = ('Image',)


registerType(SimpleChapter, PROJECTNAME)
registerType(ImageCollection, PROJECTNAME)
