# -*- coding: utf-8 -*-

# Imports: Zope
from zope.interface import implements

# Imports: Archetypes
from Products.Archetypes.public import registerType

# Imports: ATCT
from Products.ATContentTypes.content.document import ATDocument

# Imports: Structured Document
from Products.StructuredDocument.config          import PROJECTNAME
from Products.StructuredDocument.interfaces      import IStructuredDocument
from Products.StructuredDocument.contents.mixins import StructuredContainer


class StructuredDocument( StructuredContainer, ATDocument ):
    """A structured document"""

    # Configuration of my type
    portal_type = metal_type    = "StructuredDocument"
    archetype_name              = "Structured Document"
    content_icon                = "structured_document_icon.gif"
    typeDescription             = "A document with paragraphs and chapters"
    typeDescMsgId               = "structured_document_desc"
    schema                      = StructuredContainer.schema.copy() + \
                                  ATDocument.schema.copy()
    
    # Contents
    global_allow                = True
    allowed_content_types       = ('SimpleChapter',
                                   'ImageCollection',
                                   'BlockCharacter',
                                   'BlockCountry',)

    # Views
    default_view                = 'structured_document_view'
    immediate_view              = 'structured_document_view'
    suppl_views                 = ('structured_document_whole',
                                   'structured_document_whole_noheader',)

    # Reorganizing schema
    schema.moveField('allowDiscussion', after='text')
    schema.moveField('relatedItems', after='allowDiscussion')
    schema['subject'].schemata = 'default'
    schema.moveField('subject', after='description')

    # Z3 implements
    implements( IStructuredDocument )


registerType(StructuredDocument,  PROJECTNAME)
