# -*- coding: utf-8 -*-

# Imports: Zope
from zope.interface import implements

# Imports: Archetypes
from Products.Archetypes.public import *

# Imports: ATCT
from Products.ATContentTypes.content.base import ATCTContent

# Imports: Structured Document
from Products.StructuredDocument.config     import PROJECTNAME
from Products.StructuredDocument.schemas    import SimpleParagraphSchema
from Products.StructuredDocument.contents   import StructuredContainer
from Products.StructuredDocument.interfaces import IListingParagraph


class ListingParagraph( ATCTContent ):
    """
    A paragraph displaying the folder listings of the related items
    """

    # Configuration of my type
    portal_type = metal_type    = "ListingParagraph"
    archetype_name              = "Listing paragraph"
    content_icon                = "simple_paragraph_icon.gif"
    typeDescription             = "A paragraph showing folder listings"
    typeDescMsgId               = "simple_paragraph_desc"
    schema                      = ATCTContent.schema.copy()
    actions                     = ATCTContent.actions
    global_allow                = False

    # Z3 implements
    implements( IListingParagraph )
    
    # Contents
    allowed_content_types       = tuple()

    # Views
    default_view                = 'structured_paragraph_view'
    immediate_view              = 'structured_paragraph_view'
    suppl_views                 = ('document_view',)


registerType(ListingParagraph, PROJECTNAME)
