# -*- coding: utf-8 -*-

# Imports: Zope
from Globals        import InitializeClass
from AccessControl  import ClassSecurityInfo
from zope.interface import implements

# Imports: Archetypes
from Products.Archetypes.public import BaseContent

# Imports: ATCT
from Products.ATContentTypes.content.base   import ATCTContent, ATCTMixin
from Products.ATContentTypes.content.base   import updateActions
from Products.ATContentTypes.content.folder import ATFolder

# Imports: Structured Document
from Products.StructuredDocument.interfaces import IStructuredContainer
from Products.StructuredDocument.interfaces import IStructuredBlock


class StructuredContainer( ATFolder ):
    """ Base container, implemented by a document and a chapter """
    
    allowed_content_types       = tuple()
    allow_discussion            = False
    _at_rename_after_creation   = True

    # Z3 interfaces
    implements( IStructuredContainer )

    # Security
    security = ClassSecurityInfo()

    security.declarePublic('canSetDefaultPage')
    def canSetDefaultPage(self):
        """
        No Default Page can be set for this folderish type
        """
        return False

InitializeClass(StructuredContainer)



class StructuredBlock( ATCTMixin, BaseContent ):
    """ Base informations block, to appear in a structured document """

    allowed_content_types       = tuple()
    allow_discussion            = False
    _at_rename_after_creation   = True

    # Z3 implements
    implements( IStructuredBlock )

    # Views
    default_view                = 'base_view'
    immediate_view              = 'base_view'
    suppl_views                 = tuple()

    # Actions
    actions = updateActions(ATCTMixin,
        ({
        'id'          : 'preview',
        'name'        : 'Preview',
        'action'      : 'string:${object_url}/block_preview',
        'permissions' : ('Modify portal content',)
        },))

InitializeClass(StructuredBlock)
