# -*- coding: utf-8 -*-

# Imports: Zope
from AccessControl  import ClassSecurityInfo
from zope.interface import implements

# Imports: Archetypes
try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *
    


# Imports: ATCT
from Products.ATContentTypes.content.base import ATCTContent

# Imports: Structured Document
from Products.StructuredDocument.config     import PROJECTNAME
from Products.StructuredDocument.schemas    import SimpleParagraphSchema
from Products.StructuredDocument.contents   import StructuredContainer
from Products.StructuredDocument.interfaces import ISimpleParagraph


class SimpleParagraph( ATCTContent ):
    """
    A simple paragraph inside a chapter.
    It does show a text and an image, easily placed on the left or right.
    This is not HistoryAware, since it has no real need to be !
    """

    # Configuration of my type
    portal_type = metal_type    = "SimpleParagraph"
    archetype_name              = "Paragraph"
    content_icon                = "simple_paragraph_icon.gif"
    typeDescription             = "A paragraph with a text and an image"
    typeDescMsgId               = "simple_paragraph_desc"
    schema                      = SimpleParagraphSchema
    actions                     = ATCTContent.actions
    global_allow                = False

    # Z3 implements
    implements( ISimpleParagraph )
    
    # Contents
    allowed_content_types       = tuple()

    # Security
    security = ClassSecurityInfo()

    # Views
    default_view                = 'structured_paragraph_view'
    immediate_view              = 'structured_paragraph_view'
    suppl_views                 = ('document_view',)


    security.declareProtected('View', 'tag')
    def tag(self, **kwargs):
        """
        Generate image tag using the api of the ImageField
        We use it here to provide a convenient way to display
        thumbnail and also to fit the summary_view requirement
        """
        if self.getImage():
            if not 'scale' in kwargs:
                kwargs['scale'] = self.getImage_scale() or 'normal'
            return self.getWrappedField('image').tag(self, **kwargs)
            
        return None

registerType(SimpleParagraph, PROJECTNAME)
