from zope.interface import Interface, Attribute

class INextPreviousView( Interface ):
    """ Interface to navigate between content in a container e.g. folder"""
    
    def next():
        """Get the next item, or None if there is no such item"""

    def previous():
        """Get the previous  item, or None if there is no such item"""

    def next_previous():
        """Get the previous AND previous items, or None if there is no such item"""


class IStructuredDocumentView( Interface ):
    """ Interface to get the structure of a structured document """
    
    def chapters():
        """Returns a list of chapters brain"""

    def information_blocks():
        """Returns the information blocks related to the document"""

    def can_add_content():
        """Returns True if the current user has the right to add content"""


class IStructuredChapterView( Interface ):
    """ Interface to get the structure of a structured document """
    
    def paragraphs():
        """Returns a list of paragraphs brain"""

    def can_add_content():
        """Returns True if the current user has the right to add content"""


class INextPreviousProvider( Interface ):
    """A folderish component capable of describing the next and previous 
    item relative to a particular id.
    """

    def getNextItem( oid ):
        """
        Returns the next item in the container
        oid is the id of the current object being viewed.
        """

    def getPreviousItem( oid ):
        """
        Returns the previous item in the container
        oid is the id of the current object being viewed.
        """

    def itemRelatives( oid ):
        """
        Returns both next and previous elements.
        """


class IStructuredActionsProvider( Interface ):
    """ Structured Content Actions Provider Interface"""

    def getActions():
        """
        """
        
    def view_actions():
        """
        """
        
    def canModify():
        """
        """


class IStructuredDocument( Interface ):
    """
    Marker interface
    """

class IStructuredChapter( Interface ):
    """
    Marker interface
    """

class IStructuredParagraphAware( Interface ):
    """
    Marker interface
    """

class IStructuredParagraph( IStructuredParagraphAware ):
    """
    Marker interface
    """

class IStructuredInformationBlock( Interface ):
    """
    Marker interface
    """

class IStructuredCharacterBlock( Interface ):
    """
    Marker interface
    """
