# -*- coding: utf-8 -*-

from zope.interface import Interface


class IListingContentProvider( Interface ):
    """ Provides the contents of a folder """

    def getContents( ):
        """
        Returns the content of the folder
        """

    def normalizeString( ):
        """
        """

    def getViewUrl( ):
        """
        """


class IAddableContentProvider( Interface ):
    """ Provides the addable contents """

    def addable_types( ):
        """
        Provides the addable types
        """        


class IDocumentContentProvider( Interface ):
    """ Interface to get the structure of a structured document """
    
    def chapters():
        """ Returns a list of chapters brain """

    def information_blocks():
        """ Returns the information blocks related to the document """

    def can_add_content():
        """ Returns True if the current user has the right to add content """

    def can_modify_content():
        """
        Returns True is you can modify the context.
        False otherwise.
        """
        

class IChapterContentProvider( Interface ):
    """ Interface to get the structure of a structured document """
    
    def paragraphs():
        """ Returns a list of paragraphs brain """

    def can_modify_content():
        """ Returns True if the current user has the right to modify the object """

    def can_add_content():
        """ Returns True if the current user has the right to add content """

    def chapter_ordering():
        """ can reorganize the paragraphs of a chapter """
        


class INextPreviousProvider( Interface ):
    """A folderish component capable of describing the next and previous 
    item relative to a particular id.
    """

    def getNextItem( oid ):
        """
        Returns the next item in the container
        oid is the id of the current object being viewed
        """

    def getPreviousItem( oid ):
        """
        Returns the previous item in the container
        oid is the id of the current object being viewed
        """

    def itemRelatives( oid ):
        """ Returns both next and previous elements """



class IStructuredActionsProvider( Interface ):
    """ Structured Content Actions Provider Interface"""

    def language():
        """
        Returns the actual language.
        """

    def actions():
        """
        Returns the list of actions of the context.
        """
        
    def view_actions():
        """
        Returns the list of the view actions. 
        """
        
    def can_modify_content():
        """
        Returns True is you can modify the context.
        False otherwise.
        """



class ICommentsProvider( Interface ):
    """ Structured Content Comments Provider Interface"""

    def allowed_comments():
        """
        Is the context allowing comments ?
        Returns True is so, False otherwise.
        """

    def can_view_comments():
        """
        Are you allowed to view the comments ?
        Returns True is so, False otherwise.
        """

    def display_add_buttons():
        """
        Are you allowed to add a comment here ?
        Returns True is so, False otherwise.
        """

    def delete_comments():
        """
        Are you allowed to delete a comment here ?
        Returns True is so, False otherwise.
        """

    def comments():
        """
        Returns the structure of the comments linked
        to the context.
        """

    def comment_creator( userid ):
        """
        A method to gets infos about the userid given
        as a parameter. Will return a dictionnary out
        of getUserInfo.
        """

    def toLocalizedTime( time, format ):
        """
        The basic Plone method to get the time
        in a localized format.
        """
