# -*- coding: utf-8 -*-

# Archetypes
from Products.Archetypes.public import BaseContent
from Products.Archetypes.public import ImageField
from Products.Archetypes.public import ImageWidget
from Products.Archetypes.public import StringField
from Products.Archetypes.public import StringWidget
from Products.Archetypes.public import SelectionWidget
from Products.Archetypes.public import Schema

from Products.StructuredDocument.config import ORIGINAL_SIZE
from Products.StructuredDocument.config import TAG_SIZES
from Products.StructuredDocument.config import TAG_NAMES


BlockCharacterSchema = BaseContent.schema.copy() + Schema((

    StringField('title',
                required = True,
                accessor = 'Title',
                widget = StringWidget(label="Character's name",
                                      label_msgid="label_character_name",
                                      description="Character's full name",
                                      description_msgid="desc_character_name",
                                      i18n_domain='structureddocument',
                                      )),
    ImageField('portrait',
               required = False,
               original_size = ORIGINAL_SIZE,
               sizes = TAG_SIZES,
               widget = ImageWidget(label="Portrait",
                                    label_msgid="label_picture",
                                    description="A portrait of the character",
                                    description_msgid="desc_picture",
                                    i18n_domain='structureddocument',
                                    )),
    StringField('image_scale',
                required = False,
                default = "normal", 
                vocabulary = TAG_NAMES,
                widget = SelectionWidget(label="Size of the portrait",
                                      label_msgid="label_sizes",
                                      description="Size of the thumbnail displayed",
                                      description_msgid="desc_sizes",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('image_comment',
                required = False,
                widget = StringWidget(label="Comment",
                                      label_msgid="label_image_comment",
                                      description="Comment about the portrait",
                                      description_msgid="desc_image_comment",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('birth_date',
                 required = False,
                 widget = StringWidget(label="Birthdate",
                                        label_msgid="label_birthdate",
                                        description="",
                                        description_msgid="",
                                        i18n_domain='structureddocument',
                                       )),
    StringField('birth_place',
                required = False,
                widget = StringWidget(label="Birth place",
                                      label_msgid="label_birthplace",
                                      description="",
                                      description_msgid="",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('death_date',
                required = False,
                widget = StringWidget(label="Death date",
                                      label_msgid="label_deathdate",
                                      description="",
                                      description_msgid="",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('death_place',
                required = False,
                widget = StringWidget(label="Death place",
                                      label_msgid="label_deathplace",
                                      description="",
                                      description_msgid="",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('country_origin',
                required = False,
                widget = StringWidget(label="Origin",
                                      label_msgid="label_origin_country",
                                      description="Country of origin (nationality or birth)",
                                      description_msgid="desc_origin_country",
                                      i18n_domain='structureddocument',
                                      )),
    ))
