# -*- coding: utf-8 -*-

# Archetypes
from Products.Archetypes.public import BaseContent
from Products.Archetypes.public import ImageField
from Products.Archetypes.public import ImageWidget
from Products.Archetypes.public import LinesField
from Products.Archetypes.public import LinesWidget
from Products.Archetypes.public import StringField
from Products.Archetypes.public import StringWidget
from Products.Archetypes.public import SelectionWidget
from Products.Archetypes.public import Schema

from Products.StructuredDocument.config import ORIGINAL_SIZE
from Products.StructuredDocument.config import TAG_SIZES
from Products.StructuredDocument.config import TAG_NAMES


BlockCountrySchema = BaseContent.schema.copy() + Schema((

    StringField('title',
                required = True,
                accessor = 'Title',
                widget = StringWidget(label="Name of the country",
                                      label_msgid="label_country_name",
                                      description="Name of the country (in english)",
                                      description_msgid="desc_country_name",
                                      i18n_domain='structureddocument',
                                      )),
    ImageField('flag',
               required = False,
               original_size = ORIGINAL_SIZE,
               sizes = TAG_SIZES,
               widget = ImageWidget(label="Flag",
                                    label_msgid="label_flag",
                                    description="A picture of the country's flag",
                                    description_msgid="desc_flag",
                                    i18n_domain='structureddocument',
                                    )),
    StringField('image_scale',
                required = False,
                default = "normal", 
                vocabulary = TAG_NAMES,
                widget = SelectionWidget(label="Size of the flag",
                                      label_msgid="label_sizes",
                                      description="Size of the thumbnail displayed",
                                      description_msgid="desc_sizes",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('image_comment',
                required = False,
                widget = StringWidget(label="Comment",
                                      label_msgid="label_image_comment",
                                      description="Comment about the portrait",
                                      description_msgid="desc_image_comment",
                                      i18n_domain='structureddocument',
                                      )),
    LinesField('local_names',
                 required = False,
                 widget = LinesWidget(label="Local names",
                                      label_msgid="label_localnames",
                                      description="Names of the country in the different dialects",
                                      description_msgid="desc_localnames",
                                      i18n_domain='structureddocument',
                                      )),

    ))
