# ATCT
from Products.ATContentTypes.content.base import ATCTContent
from Products.ATContentTypes.configuration import zconf

# Archetypes
from Products.Archetypes.public import ImageField
from Products.Archetypes.public import ImageWidget
from Products.Archetypes.public import IntegerField
from Products.Archetypes.public import IntegerWidget
from Products.Archetypes.public import StringField
from Products.Archetypes.public import StringWidget
from Products.Archetypes.public import TextField
from Products.Archetypes.public import RichWidget
from Products.Archetypes.public import BooleanField
from Products.Archetypes.public import BooleanWidget
from Products.Archetypes.public import SelectionWidget
from Products.Archetypes.public import Schema


from Products.StructuredDocument.config import ORIGINAL_SIZE
from Products.StructuredDocument.config import TAG_SIZES
from Products.StructuredDocument.config import TAG_NAMES


SimpleParagraphSchema = ATCTContent.schema.copy() + Schema((
    TextField('text',
              required=True,
              searchable=True,
              primary=True,
              validators = ('isTidyHtmlWithCleanup',),
              default_content_type = zconf.ATDocument.default_content_type,
              default_output_type = 'text/x-html-safe',
              allowable_content_types = zconf.ATDocument.allowed_content_types,
              widget = RichWidget(
                        description = "",
                        description_msgid = "help_body_text",
                        label = "Body Text",
                        label_msgid = "label_body_text",
                        rows = 25,
                        i18n_domain = "plone",
                        allow_file_upload = zconf.ATDocument.allow_document_upload)),
    ImageField('image',
               required = False,
               original_size = ORIGINAL_SIZE,
               sizes = TAG_SIZES,
               widget = ImageWidget(label="Image",
                                    label_msgid="label_picture",
                                    description="Optional image",
                                    description_msgid="desc_picture",
                                    i18n_domain='structureddocument',
                                    )),
    StringField('image_scale',
                required = False,
                default = "normal", 
                vocabulary = TAG_NAMES,
                widget = SelectionWidget(label="Size of the image",
                                      label_msgid="label_sizes",
                                      description="Size of the thumbnail displayed in the paragraph's body",
                                      description_msgid="desc_sizes",
                                      i18n_domain='structureddocument',
                                      )),
    StringField('image_comment',
                required = False,
                widget = StringWidget(label="Comment",
                                      label_msgid="label_image_comment",
                                      description="Comment about the image",
                                      description_msgid="desc_image_comment",
                                      i18n_domain='structureddocument',
                                      )),
    BooleanField('aligned',
                 required = False,
                 widget = BooleanWidget(label="Align the image on the right",
                                        label_msgid="label_aligned_picture",
                                        description="Align the image on the right.  \
                                        By default, the image is positionned on the left \
                                        side, before the text.",
                                        description_msgid="desc_aligned_picture",
                                        i18n_domain='structureddocument',
                                        )),
    ))

SimpleParagraphSchema['description'].schemata = 'metadata'
SimpleParagraphSchema['title'].required = False
del SimpleParagraphSchema['relatedItems']
